// ==========================================================================
// $Id: vector3d.h,v 1.1 2013/11/06 17:36:04 jlang Exp $
// CSI2372 example Code for lecture 13
// ==========================================================================
// (C)opyright:
//
//   Jochen Lang
//   SITE, University of Ottawa
//   800 King Edward Ave.
//   Ottawa, On., K1N 6N5
//   Canada. 
//   http://www.site.uottawa.ca
// 
// Creator: jlang (Jochen Lang)
// Email:   jlang@site.uottawa.ca
// ==========================================================================
// $Log: vector3d.h,v $
// Revision 1.1  2013/11/06 17:36:04  jlang
// Matrix friendship without operators
//
// Revision 1.2  2006/11/20 21:34:07  jlang
// Added friend/inline/static demo
//
//
// ==========================================================================
#ifndef VECTOR_3D_
#define VECTOR_3D_

#include <iostream>
#include "matrix3d.h"

using std::ostream;
using std::endl;

class Vector3D {
  // grant friendship to operator only
  friend Vector3D Matrix3D::mul( Vector3D& );
  // could also grant friendship to class by
  // friend class Matrix3D;

  // const integral constant can be initialized here 
  static const int NUM_ELEM = 3;

  // const double must be initialized outside the class
  // -- actually gcc 4.0.2 compiles it anyways
  // but the standard, section 9.4.2 is clear:
  // "If a static data member is of const integral or const enumeration
  // type, its declaration in the class definition can specify a
  // constant-initializer which shall be a constant integral
  // expression."
  const static double ZERO;

  double d_components[NUM_ELEM];
public:
  Vector3D( double _x = 0.0, double _y=0.0, double _z=0.0 );
  bool isNotZero();
  friend 
  ostream& operator<< ( ostream &os, const Vector3D& _vec );
};



#endif
